import type { IExecuteResult, IActionConfig, ExecuteFunc } from '../actions';
import type { ACTION_ADDONS } from './common';
/** Массив экшн конфигов. */
export declare type ButtonsConfig<T extends IActionInfo<any, any>> = T[];
/** Экшн конфиг. */
export interface IActionInfo<TContext, TResult> {
    /**
     * Предварительное действие, которое будет исполнено, перед исполнением самого действия.
     * Сигнатура предварительного действия такая-же как и у основного действия.
     * Если валидация предварительного действия будет провалена, то валидация всего экшна будет провалена.
     *
     * Так-же, если результат вызова предварительного действия содержит элементы, обработка которых провалилась
     * (т.е. Массив `failed[]` не пустой), то основное действие не будет вызвано.
     */
    preAction?: IActionInfo<TContext, TResult>;
    /**
     * Название действия.
     * Должно отражать суть действия, например: `print-document`, `sign-and-send` и т.д.
     */
    name: string;
    /**
     * Основное действие, которое требуется выполнить экзекутором.
     */
    action: IActionConfig<TContext, TResult>;
    /**
     * Функция будет вызвана после успешного исполнения действия и получит ее результаты в качестве аргумента.
     *
     * @param result Результат исполнения основного действия.
     * @param execute Функция `execute` экзекутора, через который был исполнен экшн.
     */
    after?(result: IExecuteResult<TContext, TResult>, execute: ExecuteFunc<any>): void;
    /**
     * Функция будет вызвана перед выполнением основного действия.
     * Если эта функция вернет `true` или что-то, то при приведении к boolean становится `true`, то основное действие не будет выполнено.
     * Если мы не хотим влиять на выполнение основного действия, то лучше ничего не возвращать.
     *
     * Если одновременно заданы `before` и `preAction`, и выполнение `preAction` было провалено, то функция `before` не будет вызвана.
     *
     * @param context Контекст экзекутора.
     * @param execute Функция `execute` экзекутора.
     */
    before?(context: TContext, execute: ExecuteFunc<any>): Promise<boolean> | boolean | void;
    /**
     * Функция для получения аргументов для экшна.
     *
     * Если функция задана, то результат этой функции перезапишет те изначальные аргументы, которые были переданы в функцию `execute`.
     */
    getProps?(): any[];
    /** Флаги, при которых выполняются дополнительные проверки. */
    addons?: ACTION_ADDONS[];
}
